/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the WebhookMutable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WebhookMutable{}

// WebhookMutable struct for WebhookMutable
type WebhookMutable struct {
	Url string `json:"url"`
	Enabled bool `json:"enabled"`
	Headers *map[string]string `json:"headers,omitempty"`
}

// NewWebhookMutable instantiates a new WebhookMutable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWebhookMutable(url string, enabled bool) *WebhookMutable {
	this := WebhookMutable{}
	this.Url = url
	this.Enabled = enabled
	return &this
}

// NewWebhookMutableWithDefaults instantiates a new WebhookMutable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWebhookMutableWithDefaults() *WebhookMutable {
	this := WebhookMutable{}
	return &this
}

// GetUrl returns the Url field value
func (o *WebhookMutable) GetUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Url
}

// GetUrlOk returns a tuple with the Url field value
// and a boolean to check if the value has been set.
func (o *WebhookMutable) GetUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Url, true
}

// SetUrl sets field value
func (o *WebhookMutable) SetUrl(v string) {
	o.Url = v
}

// GetEnabled returns the Enabled field value
func (o *WebhookMutable) GetEnabled() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Enabled
}

// GetEnabledOk returns a tuple with the Enabled field value
// and a boolean to check if the value has been set.
func (o *WebhookMutable) GetEnabledOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Enabled, true
}

// SetEnabled sets field value
func (o *WebhookMutable) SetEnabled(v bool) {
	o.Enabled = v
}

// GetHeaders returns the Headers field value if set, zero value otherwise.
func (o *WebhookMutable) GetHeaders() map[string]string {
	if o == nil || IsNil(o.Headers) {
		var ret map[string]string
		return ret
	}
	return *o.Headers
}

// GetHeadersOk returns a tuple with the Headers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookMutable) GetHeadersOk() (*map[string]string, bool) {
	if o == nil || IsNil(o.Headers) {
		return nil, false
	}
	return o.Headers, true
}

// HasHeaders returns a boolean if a field has been set.
func (o *WebhookMutable) HasHeaders() bool {
	if o != nil && !IsNil(o.Headers) {
		return true
	}

	return false
}

// SetHeaders gets a reference to the given map[string]string and assigns it to the Headers field.
func (o *WebhookMutable) SetHeaders(v map[string]string) {
	o.Headers = &v
}

func (o WebhookMutable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WebhookMutable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["url"] = o.Url
	toSerialize["enabled"] = o.Enabled
	if !IsNil(o.Headers) {
		toSerialize["headers"] = o.Headers
	}
	return toSerialize, nil
}

type NullableWebhookMutable struct {
	value *WebhookMutable
	isSet bool
}

func (v NullableWebhookMutable) Get() *WebhookMutable {
	return v.value
}

func (v *NullableWebhookMutable) Set(val *WebhookMutable) {
	v.value = val
	v.isSet = true
}

func (v NullableWebhookMutable) IsSet() bool {
	return v.isSet
}

func (v *NullableWebhookMutable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWebhookMutable(val *WebhookMutable) *NullableWebhookMutable {
	return &NullableWebhookMutable{value: val, isSet: true}
}

func (v NullableWebhookMutable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWebhookMutable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


